#include <stdio.h>
#include <stdlib.h>
#include <string.h>


struct cliente {
       char nome[30];
       char codfisc[17];
       int tipo;
       };

struct atomo {
       struct cliente dato;
       struct atomo *next;
       };
struct coda {
       struct atomo *primo,*ultimo;
       };
       
struct operazione {
       char codfisc[17];
       float importo;
       char data[10];
       int tipo;
       };
       
void in_coda(struct coda *Q, struct cliente c)
{
     struct atomo *aux;
     
     aux=malloc(sizeof(struct atomo));
     
     if(aux)
      {  aux->dato=c;
         aux->next=NULL;
         
        if(Q->primo==NULL)
            Q->primo=aux;
        else Q->ultimo->next=aux;
        Q->ultimo=aux;
      }
}

void visualizza_coda(struct coda Q)
{
     struct atomo *l;
     
     l=Q.primo;
     while(l!=NULL)
      { printf("Nome %s\n",l->dato.nome);
        printf("Cod. fiscale %s\n",l->dato.codfisc);
        l=l->next;
      }
}

struct operazione out_coda(struct coda *Q)
{
       struct operazione op;
       struct atomo *aux;
       /* invochiamo questa funzione solo se 
           la coda non e' vuota*/
       aux=Q->primo;
       Q->primo=aux->next;
       strcpy(op.codfisc,aux->dato.codfisc);
       op.tipo=aux->dato.tipo;
       printf("Importo ");
       scanf("%f",&op.importo);
       printf("Data ");
       scanf("%s",op.data);
       free(aux);
       if(Q->primo==NULL)
          Q->ultimo=NULL;
          
       return op;
}

void ins_operazione(struct operazione *T[4], int N[4], struct operazione op)
{
     struct operazione *aux;
     int i;
     
     i=op.tipo;
     aux=realloc(T[i],sizeof(struct operazione)*(N[i]+1));
     if(aux)
       {   T[i]=aux;
           T[i][N[i]]=op;
           N[i]++;
       }
}

void visualizza_operazioni(struct operazione *T[4], int N[4])
{
     int i,j;
     char data[10];
     
     
     printf("Data operazioni ");
     scanf("%s",data);
     for(i=0;i<4;i++)
      for(j=0;j<N[i];j++)
        if(strcmp(data,T[i][j].data)==0)
        /* se la data e' quella indicata */
         { printf("Cod. fisc %s\n",T[i][j].codfisc);
           printf("Importo %f\n",T[i][j].importo);
         }
}

main() {
   struct coda QQ[4];
   struct operazione *T[4],op;
   int N[4];
   int selezione,i;
   struct cliente cl;
   struct atomo *aux;
   
   
   /* inizializzazione */
    for(i=0;i<4;i++)
      { QQ[i].primo=NULL;
        QQ[i].ultimo=NULL;
        T[i]=NULL;
        N[i]=0;
      }
      
               
     do {
        printf("\nScegli tra\n");
        printf("1) Ins. in coda\n");
        printf("2) Visualizza una  coda\n");
        printf("3) Servi una coda e inserisci operazione in tabella\n");
        printf("4) Visualizza perazioni per data\n");
        printf("0) Fine\n");
        scanf("%d",&selezione);
        switch(selezione) {
         case 1:   printf("Nome ");
                   scanf("%s",cl.nome);
                   printf("Cod. fiscale ");
                   scanf("%s",cl.codfisc);
                   printf("Tipo di operazione ");
                   scanf("%d",&cl.tipo);
                   i=cl.tipo;
                   in_coda(&QQ[i],cl);
                   break;
         case 2:   printf("Coda da visualizzare ");
                   scanf("%d",&i);
                   visualizza_coda(QQ[i]);
                   break;
         case 3:   printf("Coda da servire ");
                   scanf("%d",&i);
                   if(QQ[i].primo!=NULL)
                   { /* se la coda non e' vuota*/
                     op=out_coda(&QQ[i]);
                    ins_operazione(T,N,op);
                    }
                   else printf("Coda vuota\n");
                   break;
        case 4:    visualizza_operazioni(T,N);
                   break;
        default:; }
        } while(selezione!=0);
        
       for(i=0;i<4;i++)
         free(T[i]);
         
       for(i=0;i<4;i++)
         while(QQ[i].primo!=NULL)
           {     aux=QQ[i].primo;
                 QQ[i].primo=aux->next;
                 free(aux);
           }
}                    
